

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class ReadTest {
   TestService tstService;
    EntityManagerFactory emf;
    int threads;
	int numberOfIterations;
    
    public ReadTest(int threads, int numberOfIterations) {
		this.threads = threads;
		this.numberOfIterations = numberOfIterations;
	}

	public static void main(String[] args){
		String usageLine = "Usage: \nReadTest <number of threads> <Number of iterations per thread>\n";
		if (args.length < 2) {
			System.out.println(usageLine);
			return;
		}
    	int threads = Integer.parseInt(args[0]);
    	int iters = Integer.parseInt(args[1]);
    	try {
    		ReadTest tst = new ReadTest(threads, iters);
			tst.testPerf();
		} catch (Exception e) {
			e.printStackTrace();
		}
    }
    public void testPerf()  {
    	emf =  Persistence.createEntityManagerFactory("contextSpacePU");
		
    	tstService=new TestService();
 			EntityManager em = emf.createEntityManager();
 			try{
 			em.getTransaction().begin();
	         tstService.createAcl("parent", (long)1, true,  em);
 			em.getTransaction().commit();
 			}
 			catch (Throwable t){
 				em.getTransaction().rollback();
 				t.printStackTrace();
 			}
 			finally{
 				em.close();
 			}
        
        List<BasicThread> bas = new ArrayList<ReadTest.BasicThread>();
        
        long startTime = System.currentTimeMillis();
        for(int i=0; i< threads; i++) {
        	BasicThread bt = new BasicThread(numberOfIterations, 100 +(i*numberOfIterations), "parent",1);
        	bas.add(bt);
        	bt.start();
        }
        
        for(int i=0; i< threads; i++) {
        	try {
				bas.get(i).join();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
        }
        
        long stopTime = System.currentTimeMillis();
        long elapsedTime = stopTime - startTime;
        System.out.println("Create duration: " + elapsedTime);
        
    }
    
 	private class BasicThread extends Thread {
 		int numberOfRequests = 100;
 		int startIndex = 1;
 		String parenttype;
 		long parentid;
 		
 		public BasicThread(int numberOfRequests, int startIndex, String parenttype, long parentid ) {
 			super();
 			this.numberOfRequests = numberOfRequests;
 			this.startIndex = startIndex;
 			this.parenttype = parenttype;
 			this.parentid=parentid;
 		}
 		
 	    public void run() {
 	    	int successCount=0;
 			for(int i=0; i < numberOfRequests;i++) {
	 			EntityManager em = emf.createEntityManager();
	 			try{
	 			em.getTransaction().begin();
	 			tstService.createAcl("child",i+startIndex,true, em);
	 			tstService.setParentAcl("child",i+startIndex,parenttype, parentid, em);
	 			em.getTransaction().commit();
	 			successCount++;
	 			}
	 			catch (Throwable t){
	 				em.getTransaction().rollback();
	 			//	t.printStackTrace();
	 			}
	 			finally{
	 				em.close();
	 			}
			}
 			System.out.println(Thread.currentThread().getName()+ " finished, success count: "+successCount);
 	    }
 	}
}
