
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Expression;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import com.contextspace.acl.model.TestEntity;

public class TestService {

    public TestService() {
     }
    
	public TestEntity readAclById(String type, long id, EntityManager em) throws Exception {

        CriteriaBuilder cb = em.getCriteriaBuilder();
	    CriteriaQuery<TestEntity> cq = cb.createQuery(TestEntity.class);
	    
	    Root<TestEntity> jai = cq.from(TestEntity.class); 
	    cq.select(jai);

	    Expression<String> expValue = jai.get("oidId");
	    Predicate subPredicate = cb.equal(expValue, id);
	    
	    Expression<String> expValue2 = jai.get("type");
	    Predicate subPredicate2 = cb.equal(expValue2, type);
	    
	    Predicate predicate = cb.and(subPredicate, subPredicate2);
	    
	    cq.where(predicate);
	    
	    TypedQuery<TestEntity> typedQuery = em.createQuery(cq);
	    try{
	    	return typedQuery.getSingleResult();
	    }
	    catch (Exception e){
	    	System.out.println("Failed to get result from query: "+cq.toString() +", "+ e.getMessage());
	    	throw e;
	    }
	}
	public TestEntity createAcl(String type, long id, boolean granting, EntityManager em)	
		throws  Exception {
		
		TestEntity JpaAclImpl = new TestEntity(type, id,  null, true);
		
		em.persist(JpaAclImpl);
		em.flush();

		TestEntity res = readAclById(type, id, em);
		
		return res;
	}

	public void setParentAcl(String type, long id, String parenttype, long parentid, EntityManager em) throws Exception {
        TestEntity acl;
        TestEntity parentAcl;
        acl = readAclById(type, id, em);
        parentAcl =  readAclById(parenttype, parentid, em);
        
        // Set the parent JpaAclImpl
        acl.setParentAcl(parentAcl);
        em.merge(acl);
        em.flush();
    }

}
